#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <signal.h>
#include "/usr/include/Neon/Neon.h"
using namespace std;

int g_loop = 1;
void finishApp(int signal)
{
    (void)signal;
    printf("\nWait to finish...\n");
    g_loop = 0;
}

int checkRoot()
{
    int user;
    user = getuid();
    if(user)
        return false;

    return true;
}

static void neon_listenTrigger(unsigned int index, int currentState)
{
	printf("DI%d trigger! currentState:%d\n", index, currentState);
}

int main()
{
    if(!checkRoot())
    {
        cout << "Need root privileges, please use sudo command..."<<endl;
        return 0;
    }

    signal(SIGINT, finishApp);

    int result=Neon_SetDITriggerCallback(neon_listenTrigger);
 

    if(result==COMMON_ERROR)
    {
        cout<<"Error!"<<endl;
	g_loop=0;
    }
    else if(result==FUN_UNSUPPORT)
    {
        cout<<"Unsupport!"<<endl;
	g_loop=0;
    }
    else
    {
        cout<<"Set Callback Success!"<<endl;
    }

    while (g_loop)
	usleep(1);

    return 0;
}

